package com.example.gromov.Adapter;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.Base64;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.example.gromov.Model.Mask;
import com.example.gromov.R;

import java.util.List;

public class AdapterMask extends BaseAdapter {
    Context mContext;
    List<Mask> listview;

    public AdapterMask(Context mContext, List<Mask> listview) {
        this.mContext = mContext;
        this.listview = listview;
    }

    @Override
    public int getCount() {
        return listview.size();
    }

    @Override
    public Object getItem(int i) {
        return listview.get(i);
    }

    @Override
    public long getItemId(int i) {
        return listview.get(i).getID();
    }


    private Bitmap getUserImager(String encodeIMG) {
        if (encodeIMG != null && !encodeIMG.equals("null")) {
            byte[] bytes = Base64.decode(encodeIMG, Base64.DEFAULT);
            return BitmapFactory.decodeByteArray(bytes, 0, bytes.length);
        }
        else{
            return null;
        }
    }

    @Override
    public View getView(int i, View view, ViewGroup viewGroup) {
        View v = View.inflate(mContext, R.layout.item_product_list, null);
        TextView Title = v.findViewById(R.id.titleTV);
        TextView Cost = v.findViewById(R.id.costTV);
        TextView StockTV = v.findViewById(R.id.stockTV);
        TextView Store = v.findViewById(R.id.storeTV);
        TextView Description = v.findViewById(R.id.descTV);
        TextView Reviews = v.findViewById(R.id.rewTV);
        ImageView Image = v.findViewById(R.id.imgProduct);

        Mask mask = listview.get(i);

        Title.setText(mask.getTitle());
        Cost.setText(Integer.toString(mask.getCost()));
        Description.setText(mask.getDescription());
        Reviews.setText(mask.getReviews());

        // Фикс отрицательных значений у остатка на Складе
        if (mask.getStockAvailability() < 0 ){
            StockTV.setText("0");
        }
        else{
            StockTV.setText(Integer.toString(mask.getStockAvailability()));
        }

        // Фикс отрицательных значений у остатка в Магазине
        if (mask.getAvailabilityInTheStore() < 0 ){
            Store.setText("0");
        }
        else{
            Store.setText(Integer.toString(mask.getAvailabilityInTheStore()));
        }

        // Если нет фото - вывод заглушки
        if (mask.getImage().isEmpty()) {
            Image.setImageResource(R.drawable.picture);
        } else {
            Image.setImageBitmap(getUserImager(mask.getImage()));
        }

        // Вывод надписи "Много" если товаров больше 5
        if(mask.getStockAvailability() > 5){
            StockTV.setText("Много");
        }
        else{
            StockTV.setText(Integer.toString(mask.getStockAvailability()));
        }



        return v;
    }
}
