package com.example.gromov;

import androidx.appcompat.app.AppCompatActivity;

import android.content.Intent;
import android.media.Image;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;

import retrofit2.Call;
import retrofit2.Callback;
import retrofit2.Response;
import retrofit2.Retrofit;
import retrofit2.converter.gson.GsonConverterFactory;

public class AddActivity extends AppCompatActivity {

    Button add;
    TextView Titleadd, Costadd, Stockadd, Storeadd, Descadd, Rewadd;
    Image img;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_add);

        add = findViewById(R.id.addAccept);
        add.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                EditText TitleAdd = findViewById(R.id.TitleAdd);
                EditText price = findViewById(R.id.CostAdd);
                EditText countSklad = findViewById(R.id.StockAdd);
                EditText countMagazine = findViewById(R.id.StoreAdd);
                EditText opisanie = findViewById(R.id.descAdd);
                EditText otzivy = findViewById(R.id.rewAdd);
                if (TitleAdd.getText().length() == 0 || price.getText().toString().length() == 0 || countSklad.getText().length() == 0 || countMagazine.getText().length() == 0 || opisanie.getText().length() == 0 || otzivy.getText().length() == 0) {
                    Toast.makeText(AddActivity.this, "Одно или несколько полей не были заполнены", Toast.LENGTH_SHORT).show();
                    return;
                } else {
                    String Name = TitleAdd.getText().toString();
                    Integer Price = Integer.valueOf(price.getText().toString());
                    Integer CountSklad = Integer.valueOf(countSklad.getText().toString());
                    Integer CountMagazine = Integer.valueOf(countMagazine.getText().toString());
                    String Opisanie = opisanie.getText().toString();
                    String Otzivy = otzivy.getText().toString();
                    PostCreate(Name, Price, CountSklad, CountMagazine, Opisanie, Otzivy, "NULL");
                    startActivity(new Intent(AddActivity.this, ListLayout.class));
                }
            }
        });
        Titleadd = findViewById(R.id.TitleAdd);
        Costadd = findViewById(R.id.CostAdd);
        Stockadd = findViewById(R.id.StockAdd);
        Storeadd = findViewById(R.id.StoreAdd);
        Descadd = findViewById(R.id.descAdd);
        Rewadd = findViewById(R.id.rewAdd);
    }



    // Класс для добавления продукта
    private void PostCreate(String Title, Integer Cost, Integer StockAvailability, Integer AvailabilityInTheStore, String Description, String Rewiews, String Image) {
        try {
            Retrofit retrofit = new Retrofit.Builder()
                    .baseUrl("https://ngknn.ru:5001/NGKNN/МамшеваЮС/Экзамен/api/")
                    .addConverterFactory(GsonConverterFactory.create())
                    .build();
            RetrofitAPI retrofitApi = retrofit.create(RetrofitAPI.class);
            DataModal dataModal = new DataModal(0, Title, Cost, StockAvailability, AvailabilityInTheStore, Description, Rewiews, Image);
            Call<DataModal> call = retrofitApi.createPost(dataModal);
            call.enqueue(new Callback<DataModal>() {
                @Override
                public void onResponse(Call<DataModal> call, Response<DataModal> response) {
                    if (!response.isSuccessful()) {
                        Toast.makeText(AddActivity.this, "Попробуйте еще раз, пожалуйста.", Toast.LENGTH_SHORT).show();
                    } else {
                        Toast.makeText(AddActivity.this, "Товар успешно добавлен", Toast.LENGTH_SHORT).show();
                        Titleadd.setText("");
                        Costadd.setText("");
                        Stockadd.setText("");
                        Storeadd.setText("");
                        Descadd.setText("");
                        Rewadd.setText("");
                    }
                }
                @Override
                public void onFailure(Call<DataModal> call, Throwable t) {
                    Toast.makeText(AddActivity.this, "Произошла ошибка при добавлении", Toast.LENGTH_SHORT).show();
                }
            });
        } catch (Exception e) {
        }
    }


}